package u8c.ui.mmpac.action;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.hr.frame.state.StateRegister;
import nc.vo.hr.tools.pub.HRAggVO;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;

public class CardRefreshAction  extends AbstractAction{
	OrderTestUI frameUI = null;
	public CardRefreshAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI1;
	}

	@Override
	public void execute() throws Exception {
		OrderTestUI ui = (OrderTestUI)this.getFrameUI();
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
//		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		
		boolean boo = mainMgrPanel.getBillCardPanel().isShowing();
		if(boo) {
			mainMgrPanel.getBillCardPanel().setBillValueVO(s);
			ui.getBillCardPanel().getBodyTabbedPane().setSelectedIndex(3);//默认显示哪个页签
		}else {
			getFrameUI().getBtnManager().getCmdByID(AbstractBtnReg.SYSBTN_REFRESH).execute();
		}
		
		
		getDataModel().setCurrentState(StateRegister.STATE_NOTEDIT); 
		
	}

}
