package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.md.model.impl.Container;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.hr.frame.state.StateRegister;
import nc.ui.hr.global.Global;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.tools.BannerDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;

public class GenOtheroutinAction extends AbstractAction{
	OrderTestUI frameUI = null;
	IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	public GenOtheroutinAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI1;
	}

	@Override
	public void execute() throws Exception {
		OrderTestUI ui = (OrderTestUI)this.getFrameUI();
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		
	//	CircularlyAccessibleValueObject[] chulidvos=s.getAllChildrenVO();
		
		String pk_order="";
		if (null != s ){
			OrderMainVO headvo = (OrderMainVO) s.getParentVO();
			String vbillno = headvo.getVbillno();
			pk_order= headvo.getPk_order();
			CircularlyAccessibleValueObject[] oldchildvos = s.getAllChildrenVO();
			OrderIssueVO[] issueArrays = getIssueVOs(oldchildvos);
			List<OrderIssueVO> execList = new ArrayList<>();
			for(OrderIssueVO issuevo : issueArrays) {
//				Object bdef3 = issuevo.getBdef3();//是否委外
//				if(bdef3 != null && bdef3.equals("Y") ) {
//					execList.add(issuevo);
//				}
				
				Object bdef5 = issuevo.getBdef5();//是否委外
				if(bdef5 != null && bdef5.equals("Y") ) {
					execList.add(issuevo);
				}
				
			}
	//		delICVos(oldchildvos);
			delICVos(s);
		
			if(execList.size() != 0) {
				AddICVosout(execList);
				AddICVosin(execList);
			}
			
			
			//查询数据库
			String sqlin="select * from  mmpac_order_otherin where pk_order='"+pk_order+"' ";
			ArrayList<OrderOtherinVO> invoslis= (ArrayList<OrderOtherinVO>) iuap.executeQuery(sqlin, new BeanListProcessor(OrderOtherinVO.class));
			String sqlout="select * from  mmpac_order_otherout where pk_order='"+pk_order+"' ";
			ArrayList<OrderOtheroutVO> outvoslis= (ArrayList<OrderOtheroutVO>) iuap.executeQuery(sqlout, new BeanListProcessor(OrderOtheroutVO.class));
			
			
			s.setTableVO("mmpac_order_otherin", invoslis.toArray(new OrderOtherinVO[0]));
			s.setTableVO("mmpac_order_otherout", outvoslis.toArray(new OrderOtheroutVO[0]));
			
			//修改是否委外数据到数据库
			ivo.updateVOArray(issueArrays);
			
			boolean boo = mainMgrPanel.getBillCardPanel().isShowing();
			if(boo) {
				mainMgrPanel.getBillCardPanel().setBillValueVO(s);
				
				ui.getBillCardPanel().getBodyTabbedPane().setSelectedIndex(2);//默认显示哪个页签
			}else {
				getFrameUI().getBtnManager().getCmdByID(AbstractBtnReg.SYSBTN_REFRESH).execute();
			}
			
			
			getDataModel().setCurrentState(StateRegister.STATE_NOTEDIT); 
			
//			getFrameUI().getBtnManager().getCmdByID(AbstractBtnReg.USERBTN_Refresh).execute();
		}
		
		
		MessageDialog.showHintDlg(frameUI, "提示", "出入库更新成功!");
	}
	
	//根据aggvo获取issuevo数组
	private OrderIssueVO[] getIssueVOs(CircularlyAccessibleValueObject[] oldchildvos) {
		List<OrderIssueVO> issuevos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : oldchildvos) {
			if(vo instanceof OrderIssueVO) {
				issuevos.add((OrderIssueVO)vo);
			}
		}
		Object[] objArrays = issuevos.toArray();
		OrderIssueVO[] issueArrays = new OrderIssueVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			issueArrays[i] = (OrderIssueVO) objArrays[i];
		}
		return issueArrays;
	}
	
	//删除已存在的出库页签
	private void delICVos(CircularlyAccessibleValueObject[] oldchildvos) {
		try {
			for(CircularlyAccessibleValueObject vo : oldchildvos) {
				if(vo instanceof OrderOtheroutVO) {
					ivo.deleteVO((OrderOtheroutVO)vo);
				}
				if(vo instanceof OrderOtherinVO) {
					ivo.deleteVO((OrderOtherinVO)vo);
				}
			}
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			MessageDialog.showErrorDlg(frameUI, "错误", e.getMessage());
			return;
		}
	}
	
	
	private void delICVos(HRAggVO s) {
		
	try {	
		OrderOtherinVO[] criavinbhects= (OrderOtherinVO[]) s.getTableVO("mmpac_order_otherin");
		
//		OrderOtheroutVO[] criavoutbhects= (OrderOtheroutVO[]) s.getTableVO("mmpac_order_otherout");
		
		if(null!=criavinbhects && criavinbhects.length>0) {
			String pk_order=criavinbhects[0].getPk_order();
		    ivo.deleteByClause(OrderOtherinVO.class, " pk_order='"+pk_order+"' and  execnum is null  ");
		    ivo.deleteByClause(OrderOtheroutVO.class, " pk_order='"+pk_order+"' and execnum is null   ");
		}
		
	    
	} catch (BusinessException e) {
		// TODO Auto-generated catch block
		MessageDialog.showErrorDlg(frameUI, "错误", e.getMessage());
		return;
	}
	}
	
	//材料出库单勾选是否委外生成出库页签--入
	private void AddICVosin(List<OrderIssueVO> execList) {
		try {
			//查询是否存生成了出入库页签数据，防止重复生成
//			String sqlin="select * from  mmpac_order_otherin where pk_order='"+execList.get(0).getPk_order()+"' ";
//			ArrayList<OrderOtherinVO> invoslis= (ArrayList<OrderOtherinVO>) iuap.executeQuery(sqlin, new BeanListProcessor(OrderOtherinVO.class));
//			String sqlout="select * from  mmpac_order_otherout where pk_order='"+execList.get(0).getPk_order()+"' ";
//			ArrayList<OrderOtheroutVO> outvoslis= (ArrayList<OrderOtheroutVO>) iuap.executeQuery(sqlout, new BeanListProcessor(OrderOtheroutVO.class));
//			
//			List<String> lisinpk=new ArrayList<String>();
//			List<String> outinpk=new ArrayList<String>();
//			
//			if(null!=invoslis &&  invoslis.size()>0) {
//				for(OrderOtherinVO invo: invoslis) {
//					lisinpk.add(invo.getBdef1());//材料明细主键
//				}
//			}
//			
//			if(null!=outvoslis &&  outvoslis.size()>0) {
//				for(OrderOtheroutVO outvo: outvoslis) {
//					outinpk.add(outvo.getBdef1());//材料明细主键
//				}
//			}
			
			String sqlin="select bdef1 from  mmpac_order_otherin where pk_order='"+execList.get(0).getPk_order()+"' ";
			ArrayList<String> invoslis= (ArrayList<String>) iuap.executeQuery(sqlin, new ColumnListProcessor());
			
			for(OrderIssueVO issuevo : execList) {
				String pk_order_issue =issuevo.getPk_order_issue();//材料明细主键
				if(null!=invoslis &&  invoslis.size()>0) {
					
					if(invoslis.contains(pk_order_issue)) {
						continue;
					}
					
				}
				OrderOtherinVO invo = new OrderOtherinVO();
				invo.setPk_order(issuevo.getPk_order());
				invo.setPrjtypecode(issuevo.getPrjtypecode());
				invo.setStandard(issuevo.getStandard());
				invo.setNum(issuevo.getNum());
				invo.setCmaterialname(issuevo.getCmaterialname());
				invo.setConf(issuevo.getConf());
				invo.setExecnum(issuevo.getExecnum());
				invo.setDr(issuevo.getDr());
				invo.setSpec(issuevo.getSpec());
				invo.setNprice(issuevo.getNprice());
				invo.setTaxprice(issuevo.getTaxprice());
				invo.setModel(issuevo.getModel());
				invo.setHeight(issuevo.getHeight());
				invo.setTax(issuevo.getTax());
				invo.setCastunitid(issuevo.getCastunitid());
				invo.setWeight(issuevo.getWeight());
				invo.setPrjtypename(issuevo.getPrjtypename());
				invo.setExecnastnum(issuevo.getExecnastnum());
				invo.setSizing(issuevo.getSizing());
				invo.setAlloy(issuevo.getAlloy());
				invo.setColor(issuevo.getColor());
				invo.setNastnum(issuevo.getNastnum());
				invo.setPrjcode(issuevo.getPrjcode());
				invo.setTaxmny(issuevo.getTaxmny());
				invo.setCmaterialcode(issuevo.getCmaterialcode());
				invo.setRound(issuevo.getRound());
				invo.setPrjname(issuevo.getPrjname());
				invo.setVbatchcode(issuevo.getVbatchcode());
				invo.setWidth(issuevo.getWidth());
				invo.setNmny(issuevo.getNmny());
				invo.setUnitid(issuevo.getUnitid());
				invo.setTs(PubEnv.getServerTime());
				invo.setBdef1(issuevo.getPk_order_issue());
				invo.setBdef6(issuevo.getBdef6());//换算率
				invo.setBdef11(issuevo.getBdef11());//楼号楼层
				invo.setBdef12(issuevo.getBdef12());//樘数（数量）
				invo.setBdef13(issuevo.getBdef13());//框统计
				invo.setBdef14(issuevo.getBdef14());//扇统计
				invo.setBdef15(issuevo.getBdef15());//半成品分类
				invo.setBdef16(issuevo.getBdef16());//面积
				invo.setBdef17(issuevo.getBdef17());//切割长度
				invo.setBdef18(issuevo.getBdef18());//切割角度左下
				invo.setBdef19(issuevo.getBdef19());//切割角度右上
				invo.setBdef20(issuevo.getBdef20());//系列
				invo.setBdef2(issuevo.getBdef2());//备注
				invo.setBdef3(issuevo.getBdef3());//玻璃编号
				ivo.insertVO(invo);

			}
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			MessageDialog.showErrorDlg(frameUI, "错误", e.getMessage());
			return;
		}
		
	}	
		
		//材料出库单勾选是否委外生成出库页签--出
		private void AddICVosout(List<OrderIssueVO> execList) {
			try {
				//查询是否存生成了出入库页签数据，防止重复生成
//				String sqlin="select * from  mmpac_order_otherin where pk_order='"+execList.get(0).getPk_order()+"' ";
//				ArrayList<OrderOtherinVO> invoslis= (ArrayList<OrderOtherinVO>) iuap.executeQuery(sqlin, new BeanListProcessor(OrderOtherinVO.class));
//				String sqlout="select * from  mmpac_order_otherout where pk_order='"+execList.get(0).getPk_order()+"' ";
//				ArrayList<OrderOtheroutVO> outvoslis= (ArrayList<OrderOtheroutVO>) iuap.executeQuery(sqlout, new BeanListProcessor(OrderOtheroutVO.class));
//				
//				List<String> lisinpk=new ArrayList<String>();
//				List<String> outinpk=new ArrayList<String>();
//				
//				if(null!=invoslis &&  invoslis.size()>0) {
//					for(OrderOtherinVO invo: invoslis) {
//						lisinpk.add(invo.getBdef1());//材料明细主键
//					}
//				}
//				
//				if(null!=outvoslis &&  outvoslis.size()>0) {
//					for(OrderOtheroutVO outvo: outvoslis) {
//						outinpk.add(outvo.getBdef1());//材料明细主键
//					}
//				}
				
				String sqlin="select bdef1 from  mmpac_order_otherout where pk_order='"+execList.get(0).getPk_order()+"' ";
				ArrayList<String> outvoslis= (ArrayList<String>) iuap.executeQuery(sqlin, new ColumnListProcessor());
				
				for(OrderIssueVO issuevo : execList) {
					String pk_order_issue =issuevo.getPk_order_issue();//材料明细主键
					if(null!=outvoslis &&  outvoslis.size()>0) {
						
						if(outvoslis.contains(pk_order_issue)) {
							continue;
						}
						
					}
					OrderOtheroutVO outvo = new OrderOtheroutVO();
					outvo.setPk_order(issuevo.getPk_order());
					outvo.setPrjtypecode(issuevo.getPrjtypecode());
					outvo.setStandard(issuevo.getStandard());
					outvo.setNum(issuevo.getNum());
					outvo.setCmaterialname(issuevo.getCmaterialname());
					outvo.setConf(issuevo.getConf());
					outvo.setExecnum(issuevo.getExecnum());
					outvo.setDr(issuevo.getDr());
					outvo.setSpec(issuevo.getSpec());
					outvo.setNprice(issuevo.getNprice());
					outvo.setTaxprice(issuevo.getTaxprice());
					outvo.setModel(issuevo.getModel());
					outvo.setHeight(issuevo.getHeight());
					outvo.setTax(issuevo.getTax());
					outvo.setCastunitid(issuevo.getCastunitid());
					outvo.setWeight(issuevo.getWeight());
					outvo.setPrjtypename(issuevo.getPrjtypename());
					outvo.setExecnastnum(issuevo.getExecnastnum());
					outvo.setSizing(issuevo.getSizing());
					outvo.setAlloy(issuevo.getAlloy());
					outvo.setColor(issuevo.getColor());
					outvo.setNastnum(issuevo.getNastnum());
					outvo.setPrjcode(issuevo.getPrjcode());
					outvo.setTaxmny(issuevo.getTaxmny());
					outvo.setCmaterialcode(issuevo.getCmaterialcode());
					outvo.setRound(issuevo.getRound());
					outvo.setPrjname(issuevo.getPrjname());
					outvo.setVbatchcode(issuevo.getVbatchcode());
					outvo.setWidth(issuevo.getWidth());
					outvo.setNmny(issuevo.getNmny());
					outvo.setUnitid(issuevo.getUnitid());
					outvo.setTs(PubEnv.getServerTime());
					outvo.setBdef1(issuevo.getPk_order_issue());
					outvo.setBdef6(issuevo.getBdef6());//换算率
					outvo.setBdef11(issuevo.getBdef11());//楼号楼层
					outvo.setBdef12(issuevo.getBdef12());//樘数（数量）
					outvo.setBdef13(issuevo.getBdef13());//框统计
					outvo.setBdef14(issuevo.getBdef14());//扇统计
					outvo.setBdef15(issuevo.getBdef15());//半成品分类
					outvo.setBdef16(issuevo.getBdef16());//面积
					outvo.setBdef17(issuevo.getBdef17());//切割长度
					outvo.setBdef18(issuevo.getBdef18());//切割角度左下
					outvo.setBdef19(issuevo.getBdef19());//切割角度右上
					outvo.setBdef20(issuevo.getBdef20());//系列
					outvo.setBdef2(issuevo.getBdef2());//备注
					outvo.setBdef3(issuevo.getBdef3());//玻璃编号
					ivo.insertVO(outvo);

				}
			} catch (BusinessException e) {
				// TODO Auto-generated catch block
				MessageDialog.showErrorDlg(frameUI, "错误", e.getMessage());
				return;
			}
		
     	}
		

}











