package u8c.ui.mmpac.action;

import java.awt.Desktop;
import java.net.URI;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderMainVO;

public class PrintBarcodeAction extends AbstractAction {
	OrderTestUI frameUI = null;
	public PrintBarcodeAction(FrameUI frameUI) {
		super(frameUI);
		this.frameUI = (OrderTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		HRAggVO [] s = (HRAggVO[]) mainMgrPanel.getMainBillListPanel().getDeleteData();
		if(s != null) {
			for (int i = 0; i < s.length; i++) {
				OrderMainVO headvo = (OrderMainVO) s[i].getParentVO();
				String vbillno = headvo.getVbillno();
				try {
					Desktop.getDesktop().browse(new URI("http://106.14.224.133:8085/jmreport/view/893491202215731200?vbillcode="+vbillno));
				}catch(Exception e) {
					MessageDialog.showHintDlg(frameUI, "提示", "打印出错");
				}
			}
		}
	}

}