package u8c.ui.mmpac.action;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.hr.frame.state.StateRegister;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.trade.pub.IBillStatus;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;

public class UpdateColorAction extends AbstractAction{
	OrderTestUI frameUI = null;
	public UpdateColorAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI1;
	}

	@Override
	public void execute() throws Exception {
	
		OrderTestUI ui = (OrderTestUI)this.getFrameUI();
		
	    MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
	    
        HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
        
        OrderMainVO headvo = (OrderMainVO) this.getSelection(mainMgrPanel).getParentVO();
		if (headvo.getBillstatus() != IBillStatus.CHECKPASS){
			throw new ValidationException("用于审批后操作，本单据不符合要求！请正常修改生成即可！");
		}
	
  //      getDataModel().setCurrentState(StateRegister.STATE_EDIT);
        
        getMainPanel().setMainPanelEnabled(true);
        
       
        
        
//      ui.getBillCardPanel().setEnabled(false);//设置面板可编辑性
      
        // 设置字段不可见
	//	BillCardPanelUtil.setBodyColsVisible(ui.getBillCardPanel(),new String[] {"bdef5"}, false, "mmpac_order_issue");
        
        for(int i=0; i<ui.getBillCardPanel().getHeadItems().length;i++) {
            //表头不可编辑
        	ui.getBillCardPanel().getHeadItems()[i].setEdit(false);
        	
        }
        
        
        //不可以编辑页签 0 表头  1 表体
  //      ui.getBillCardPanel().setTabEnabled(1, "mmpac_order_in", false);//不可以点页签
        
        
        ui.getBillCardPanel().getBodyTabbedPane().setSelectedIndex(3);//默认显示哪个页签
        
        ui.getBillCardPanel().getBillModel("mmpac_order_in").setEnabledAllItems(false); //都不可编辑
        
        ui.getBillCardPanel().getBillModel("mmpac_order_issue").setEnabledAllItems(false); //都不可编辑
        
        ui.getBillCardPanel().getBillModel("mmpac_order_otherin").setEnabledAllItems(false); //都不可编辑
        
        ui.getBillCardPanel().getBillModel("mmpac_order_otherout").setEnabledAllItems(false); //都不可编辑
        
      
        
        
//        CircularlyAccessibleValueObject[] criavoubhects= s.getTableVO("mmpac_order_otherout");
//        
//        if(null!=criavoubhects && criavoubhects.length>0) {
//        	  OrderOtheroutVO[] outvos= (OrderOtheroutVO[]) s.getTableVO("mmpac_order_otherout");
//              for(int row=0;row<outvos.length;row++) {
//                  ui.getBillCardPanel().getBillModel("mmpac_order_otherout").setCellEditable(row,"color", true);//可编辑
//               }
//                
//        }
        
        
        CircularlyAccessibleValueObject[] criavoubhects= s.getTableVO("mmpac_order_otherin");
        
        if(null!=criavoubhects && criavoubhects.length>0) {
        	OrderOtherinVO[] invos= (OrderOtherinVO[]) s.getTableVO("mmpac_order_otherin");
              for(int row=0;row<invos.length;row++) {
                  ui.getBillCardPanel().getBillModel("mmpac_order_otherin").setCellEditable(row,"color", true);//可编辑
               }
                
        }
        
      
        
	}

}









