package nc.ui.so.so002;

import nc.ui.pub.ButtonObject;
import nc.ui.pub.pf.PfUtilClient;
import nc.ui.scm.pub.bill.ButtonTree;
import nc.ui.scm.pub.bill.ScmButtonConst;
import nc.vo.pub.BusinessException;
import nc.vo.scm.pub.SCMEnv;

public class SaleInvoiceBtn {
	public final String BTN_ATP = "可用量";
	public final String BTN_CUSTINFO = "客户信息";
	public final String BTN_CUSTCREDIT = "客户信用";
	public final String BTN_PRIFIT = "毛利预估";
	public final String BTN_SoTax = "传金税";
	public final String BTN_UniteInvoice = "合并开票";
	public final String BTN_UniteCancel = "放弃合并";
	public final String BTN_Gathe = "出库汇总开票";
	public final String BTN_ExecRpt = "发票执行情况";
	public final String BTN_AuditFlowStatus = "审批流状态";
	public final String BTN_OpposeAct = "生成对冲发票";
	public final String BTN_RefAdd = "参照增行";
	public final String BTN_FetchCost = "取成本价";
	public final String BTN_CardEdit = "卡片编辑";
	public final String BTN_ReRowNO = "重排行号";
	public final String BTN_ImportTaxCode = "导入税票号";
	public final String BTN_ToEinv = "申请开票";
	private ButtonTree bt = null;
	public ButtonObject m_boBusiType = null;
	public ButtonObject m_boAdd = null;
	public ButtonObject m_boSave = null;
	public ButtonObject m_boMaintain = null;
	public ButtonObject m_boModify = null;
	public ButtonObject m_boCancel = null;
	public ButtonObject m_boBlankOut = null;
	public ButtonObject m_boCancelTransfer = null;
	public ButtonObject m_boUnite = null;
	public ButtonObject m_boUniteCancel = null;
	public ButtonObject m_boLineOper = null;
	public ButtonObject m_boAddLine = null;
	public ButtonObject m_boDelLine = null;
	public ButtonObject m_boInsertLine = null;
	public ButtonObject m_boCopyLine = null;
	public ButtonObject m_boPasteLine = null;
	public ButtonObject m_boPasteLineTail = null;
	public ButtonObject m_boCardEdit = null;
	public ButtonObject m_boReRowNO = null;
	public ButtonObject m_boRefAdd = null;
	public ButtonObject m_boFetchCost = null;
	public ButtonObject m_boApprove = null;
	public ButtonObject m_boAction = null;
	public ButtonObject m_boSendAudit = null;
	public ButtonObject m_boTakeBack = null;
	public ButtonObject m_boUnApprove = null;
	public ButtonObject m_boQuery = null;
	public ButtonObject m_boBrowse = null;
	public ButtonObject m_boRefresh = null;
	public ButtonObject m_boLocal = null;
	public ButtonObject m_boFirst = null;
	public ButtonObject m_boPrev = null;
	public ButtonObject m_boNext = null;
	public ButtonObject m_boLast = null;
	public ButtonObject m_boSelectAll = null;
	public ButtonObject m_boUnSelectAll = null;
	public ButtonObject m_boCard = null;
	public ButtonObject m_boPrintManage = null;
	public ButtonObject m_boPreview = null;
	public ButtonObject m_boPrint = null;
	public ButtonObject m_boBillCombin = null;
	public ButtonObject m_boGather = null;
	public ButtonObject m_boAssistFunction = null;
	public ButtonObject m_boOpposeAct = null;
	public ButtonObject m_boSoTax = null;
	public ButtonObject m_boDocument = null;
	public ButtonObject m_boImportTaxCode = null;
	public ButtonObject m_boToEinv = null;
	public ButtonObject m_boAssistant = null;
	public ButtonObject m_boOrderQuery = null;
	public ButtonObject m_boATP = null;
	public ButtonObject m_boAuditFlowStatus = null;
	public ButtonObject m_boCustInfo = null;
	public ButtonObject m_boExecRpt = null;
	public ButtonObject m_boCustCredit = null;
	public ButtonObject m_boPrifit = null;
	private ButtonObject[] aryButtonGroup = null;
	
	 public ButtonObject m_bocount = null ;//分摊按钮
	

	public String getBusiType() {
		if (null != this.m_boBusiType.getChildButtonGroup() && this.m_boBusiType.getChildButtonGroup().length > 0) {
			ButtonObject[] var1 = this.m_boBusiType.getChildButtonGroup();
			int var2 = var1.length;

			for (int var3 = 0; var3 < var2; ++var3) {
				ButtonObject chidbtn = var1[var3];
				if (chidbtn.isSelected()) {
					return chidbtn.getTag();
				}
			}

			return this.m_boBusiType.getChildButtonGroup()[0].getTag();
		} else {
			return null;
		}
	}

	public ButtonObject[] getButtonArray() {
		return this.aryButtonGroup;
	}

	public void setStateByBillStatus(SaleInvoiceListPanel listPanel) {
		int iState = listPanel.getBillStatus();
		switch (iState) {
			case 1 :
				this.m_boBlankOut.setEnabled(true);
				this.m_boModify.setEnabled(true);
				this.m_boApprove.setEnabled(true);
				this.m_boUnApprove.setEnabled(false);
				this.m_boDocument.setEnabled(true);
				this.m_boOrderQuery.setEnabled(true);
				this.m_boOrderQuery.setEnabled(true);
				break;
			case 2 :
				this.m_boBlankOut.setEnabled(false);
				this.m_boApprove.setEnabled(false);
				this.m_boUnApprove.setEnabled(true);
				this.m_boModify.setEnabled(false);
				this.m_boDocument.setEnabled(true);
				this.m_boOrderQuery.setEnabled(true);
				this.m_boOrderQuery.setEnabled(false);
			case 3 :
			case 4 :
			case 6 :
			default :
				break;
			case 5 :
				this.m_boModify.setEnabled(false);
				this.m_boAction.setEnabled(false);
				this.m_boAssistant.setEnabled(false);
				this.m_boPrint.setEnabled(false);
				this.m_boDocument.setEnabled(false);
				this.m_boOrderQuery.setEnabled(false);
				this.m_boOrderQuery.setEnabled(false);
				this.m_boPreview.setEnabled(false);
				this.m_boAuditFlowStatus.setEnabled(false);
				break;
			case 7 :
				this.m_boBlankOut.setEnabled(false);
				this.m_boApprove.setEnabled(true);
				this.m_boUnApprove.setEnabled(false);
				this.m_boSave.setEnabled(false);
				this.m_boModify.setEnabled(false);
				break;
			case 8 :
				this.m_boBlankOut.setEnabled(true);
				this.m_boModify.setEnabled(true);
				this.m_boSave.setEnabled(false);
				this.m_boCancel.setEnabled(false);
				this.m_boApprove.setEnabled(true);
				this.m_boUnApprove.setEnabled(false);
				this.m_boDocument.setEnabled(true);
				this.m_boOrderQuery.setEnabled(true);
				this.m_boOrderQuery.setEnabled(true);
		}

		int selectRow = listPanel.getHeadTable().getSelectedRow();
		int iOppStatus = 0;
		if (selectRow > -1 && listPanel.getHeadItem("fcounteractflag") != null
				&& listPanel.getHeadBillModel().getValueAt(selectRow, "fcounteractflag") != null
				&& listPanel.getHeadItem("fcounteractflag")
						.converType(listPanel.getHeadBillModel().getValueAt(selectRow, "fcounteractflag")) != null) {
			iOppStatus = Integer.parseInt(listPanel.getHeadItem("fcounteractflag")
					.converType(listPanel.getHeadBillModel().getValueAt(selectRow, "fcounteractflag")).toString());
		}

		if (iState == 2 && iOppStatus == 1) {
			this.m_boUnApprove.setEnabled(false);
		}

		if (iState == 2 && iOppStatus == 0) {
			this.m_boOpposeAct.setEnabled(true);
		} else {
			this.m_boOpposeAct.setEnabled(false);
		}

	}

	public SaleInvoiceBtn() {
		try {
			this.bt = new ButtonTree(SaleInvoiceTools.getNodeCode());
		} catch (BusinessException var7) {
			SCMEnv.out(var7);
			return;
		}

		this.m_boBusiType = this.bt.getButton("业务类型");
		this.m_boAdd = this.bt.getButton("增加");
		this.m_bocount= this.bt.getButton("分摊");
		PfUtilClient.retBusiAddBtn(this.m_boBusiType, this.m_boAdd, SaleInvoiceTools.getLoginPk_Corp(), "32");
		ButtonObject[] busitypebtns = this.m_boBusiType.getChildButtonGroup();
		if (null != busitypebtns && busitypebtns.length > 0) {
			busitypebtns[0].setSelected(true);
		}

		this.m_boBusiType.setCheckboxGroup(true);
		this.m_boRefAdd = this.bt.getButton("参照增行");
		this.m_boRefAdd.removeAllChildren();
		ButtonObject[] var2 = this.m_boAdd.getChildButtonGroup();
		int var3 = var2.length;

		for (int var4 = 0; var4 < var3; ++var4) {
			ButtonObject childbtn = var2[var4];
			ButtonObject newbtn = new ButtonObject(childbtn.getName(), childbtn.getHint(), childbtn.getCode());
			newbtn.setTag(childbtn.getTag());
			newbtn.setPowerContrl(false);
			this.m_boRefAdd.addChildButton(newbtn);
		}

		this.m_boFetchCost = this.bt.getButton("取成本价");
		this.m_boSave = this.bt.getButton("保存");
		this.m_boMaintain = this.bt.getButton("维护");
		this.m_boModify = this.bt.getButton("修改");
//		this.m_bocount = this.bt.getButton(ScmButtonConst.BTN_COUNT);//add by ZTH
		this.m_boCancel = this.bt.getButton("取消");
		this.m_boBlankOut = this.bt.getButton("删除");
		this.m_boCancelTransfer = this.bt.getButton("放弃转单");
		this.m_boUnite = this.bt.getButton("合并开票");
		this.m_boUniteCancel = this.bt.getButton("放弃合并");
		this.m_boLineOper = this.bt.getButton("行操作");
		this.m_boAddLine = this.bt.getButton("增行");
		this.m_boDelLine = this.bt.getButton("删行");
		this.m_boInsertLine = this.bt.getButton("插入行");
		this.m_boCopyLine = this.bt.getButton("复制行");
		this.m_boPasteLine = this.bt.getButton("粘贴行");
		this.m_boPasteLineTail = this.bt.getButton("粘贴行到表尾");
		this.m_boCardEdit = this.bt.getButton("卡片编辑");
		this.m_boReRowNO = this.bt.getButton("重排行号");
		this.m_boApprove = this.bt.getButton("审核");
		this.m_boAction = this.bt.getButton("执行");
		this.m_boSendAudit = this.bt.getButton("送审");
		this.m_boTakeBack = this.bt.getButton("收回");
		this.m_boUnApprove = this.bt.getButton("弃审");
		this.m_boQuery = this.bt.getButton("查询");
//		this.m_bocount = this.bt.getButton("分摊2");
		this.m_boBrowse = this.bt.getButton("浏览");
		this.m_boRefresh = this.bt.getButton("刷新");
		this.m_boLocal = this.bt.getButton("定位");
		this.m_boFirst = this.bt.getButton("首页");
		this.m_boPrev = this.bt.getButton("上页");
		this.m_boNext = this.bt.getButton("下页");
		this.m_boLast = this.bt.getButton("末页");
		this.m_boSelectAll = this.bt.getButton("全选");
		this.m_boUnSelectAll = this.bt.getButton("全消");
		this.m_boCard = this.bt.getButton("卡片显示/列表显示");
		this.m_boPrintManage = this.bt.getButton("打印管理");
		this.m_boPreview = this.bt.getButton("预览");
		this.m_boPrint = this.bt.getButton("打印");
		this.m_boBillCombin = this.bt.getButton("合并显示");
		this.m_boGather = this.bt.getButton("出库汇总开票");
		this.m_boAssistFunction = this.bt.getButton("辅助功能");
		this.m_boOpposeAct = this.bt.getButton("生成对冲发票");
		this.m_boSoTax = this.bt.getButton("传金税");
		this.m_boDocument = this.bt.getButton("文档管理");
		this.m_boImportTaxCode = this.bt.getButton("导入税票号");
		this.m_boToEinv = this.bt.getButton("申请开票");
		this.m_boAssistant = this.bt.getButton("辅助查询");
		this.m_boOrderQuery = this.bt.getButton("联查");
		this.m_boATP = this.bt.getButton("可用量");
		this.m_boATP.setVisible(false);
		this.m_boAuditFlowStatus = this.bt.getButton("审批流状态");
		this.m_boCustInfo = this.bt.getButton("客户信息");
		this.m_boExecRpt = this.bt.getButton("发票执行情况");
		this.m_boCustCredit = this.bt.getButton("客户信用");
		this.m_boPrifit = this.bt.getButton("毛利预估");
		this.m_boATP.setTag("ATP");
		this.m_boCustInfo.setTag("CustInfo");
		this.m_boCustCredit.setTag("CustCredited");
		this.m_boPrifit.setTag("Prifit");
		this.m_boSoTax.setTag("SoTax");
		this.m_boApprove.setTag("APPROVE");
		this.m_boBlankOut.setTag("SoBlankOut");
		this.m_boUnApprove.setTag("SoUnApprove");
		this.m_boUnite.setTag("UNITE");
		this.m_boUniteCancel.setTag("UNUNITE");
		this.m_boSendAudit.setTag("SAVE");
//		this.m_bocount = this.bt.getButton("分摊2");
		this.aryButtonGroup = this.bt.getButtonArray();
	}

	public void changeButtonsWhenBusiTypeSelected(ButtonObject bo) {
		this.m_boBusiType.setTag(bo.getTag());
		PfUtilClient.retAddBtn(this.m_boAdd, SaleInvoiceTools.getLoginPk_Corp(), "32", bo);
		PfUtilClient.retAddBtn(this.m_boRefAdd, SaleInvoiceTools.getLoginPk_Corp(), "32", bo);
		boolean isBizAutoRegister = false;

		try {
			isBizAutoRegister = SaleinvoiceBO_Client.isBizAutoRegister(this.getBusiType());
		} catch (Exception var4) {
			SCMEnv.out(var4);
		}

		if (isBizAutoRegister) {
			this.m_boAdd.addChildButton(this.m_boGather);
		}

	}

	public ButtonObject[] getApproveActionButtonAry() {
		return new ButtonObject[]{this.m_boDocument, this.m_boAuditFlowStatus, this.m_boApprove, this.m_boOrderQuery};
	}
}